ldap,mysql,pgsql: use bash pipefail option so that failed dumps are reported as such
[matthijs/upstream/backupninja.git] / handlers / mysql.in
index a4a3667ffff87058640caca4767a728f8d9b66ea..3488c511becd6ecd8f247d4f2f476f9303d2fcbd 100644 (file)
@@ -1,4 +1,5 @@
 # -*- mode: sh; sh-basic-offset: 3; indent-tabs-mode: nil; -*-
+# vim: set filetype=sh sw=3 sts=3 expandtab autoindent:
 #
 # mysql handler script for backupninja
 #
@@ -89,27 +90,33 @@ if [ "$dbusername" != "" -a "$dbpassword" != "" ]
 then
    if [ $usevserver = yes ]
    then
-      vhome=`$VSERVER $vsname exec getent passwd "root" | @AWK@ -F: '{print $6}'`
-   home="$vroot$vhome"
+      home=`$VSERVER $vsname exec getent passwd "root" | @AWK@ -F: '{print $6}'`
    else
       home=`getent passwd "root" | @AWK@ -F: '{print $6}'`
    fi
 
    [ -d $home ] || fatal "Can't find root's home directory ($home)."
-
+    
    mycnf="$home/.my.cnf"
 
-   if [ -f $mycnf ]
+   if [ $usevserver = yes ]
    then
-   # rename temporarily
-   tmpcnf="$home/my.cnf.disable"
-   debug "mv $mycnf $tmpcnf"
-   mv $mycnf $tmpcnf
+      workcnf="$vroot$mycnf"
+   else
+      workcnf="$mycnf"
    fi
 
+   if [ -f $workcnf ]
+   then
+      # rename temporarily
+      tmpcnf="$workcnf.disable"
+      debug "mv $workcnf $tmpcnf"
+      mv $workcnf $tmpcnf
+   fi
+    
    oldmask=`umask`
    umask 077
-   cat > $mycnf <<EOF
+   cat > $workcnf <<EOF
 # auto generated backupninja mysql conf
 [mysql]
 host=$dbhost
@@ -125,14 +132,14 @@ password="$dbpassword"
 host=$dbhost
 user=$dbusername
 password="$dbpassword"
+
+[mysqladmin]
+host=$dbhost
+user=$dbusername
+password="$dbpassword"
 EOF
    umask $oldmask
-   if [ $usevserver = yes ]
-   then
-      defaultsfile="--defaults-extra-file=$vhome/.my.cnf"
-   else
-      defaultsfile="--defaults-extra-file=$mycnf"
-   fi
+   defaultsfile="--defaults-extra-file=$mycnf"
 fi
 
 # if a user is not set, use $configfile, otherwise use $mycnf
@@ -143,22 +150,23 @@ else
    userset=true;
    if [ $usevserver = yes ]
    then
-      vuserhome=`$VSERVER $vsname exec getent passwd "$user" | @AWK@ -F: '{print $6}'`
+      userhome=`$VSERVER $vsname exec getent passwd "$user" | @AWK@ -F: '{print $6}'`
       if [ $? -eq 2 ]
       then
-         fatal "User $user not found in /etc/passwd"
+        fatal "User $user not found in /etc/passwd"
       fi
-         userhome="$vroot$vuserhome"
+      debug "User home set to: $vroot$userhome"
+      [ -f $vroot$userhome/.my.cnf ] || fatal "Can't find config file in $userhome/.my.cnf"
    else
       userhome=`getent passwd "$user" | @AWK@ -F: '{print $6}'`
       if [ $? -eq 2 ]
       then
-         fatal "User $user not found in /etc/passwd"
+        fatal "User $user not found in /etc/passwd"
       fi
-         fi
-
-   debug "User home set to: $userhome"
-   [ -f $userhome/.my.cnf ] || fatal "Can't find config file in $userhome/.my.cnf"
+      debug "User home set to: $userhome"
+      [ -f $userhome/.my.cnf ] || fatal "Can't find config file in $userhome/.my.cnf"
+   fi
+       
    defaultsfile="--defaults-extra-file=$userhome/.my.cnf"
    debug "using $defaultsfile"
 fi
@@ -229,14 +237,14 @@ then
    then
       if [ $usevserver = yes ]
       then
-         debug 'echo show databases | $VSERVER $vsname exec su $user -c \"$MYSQL $defaultsfile\" | grep -v Database'
-         databases=`echo 'show databases' | $VSERVER $vsname exec su $user -c "$MYSQL $defaultsfile" | grep -v Database`
+         debug 'set -o pipefail ; echo show databases | $VSERVER $vsname exec su $user -c \"$MYSQL $defaultsfile\" | grep -v Database'
+         databases=`set -o pipefail ; echo 'show databases' | $VSERVER $vsname exec su $user -c "$MYSQL $defaultsfile" | grep -v Database`
          if [ $? -ne 0 ]
          then
             fatal "Authentication problem, maybe user/password is wrong or mysqld is not running?"
          fi
       else
-         databases=$(su $user -c "$MYSQL $defaultsfile -N -B -e 'show databases'" | sed 's/|//g;/\+----/d')
+         databases=$(set -o pipefail ; su $user -c "$MYSQL $defaultsfile -N -B -e 'show databases'" | sed 's/|//g;/\+----/d')
          if [ $? -ne 0 ]
          then
             fatal "Authentication problem, maybe user/password is wrong or mysqld is not running?"
@@ -271,9 +279,9 @@ then
             fatal "mysqld doesn't appear to be running!"
          fi
          if [ "$compress" == "yes" ]; then
-            execstr="$VSERVER $vsname exec $DUMP | $GZIP > $vroot$dumpdir/${db}.sql.gz"
+            execstr="$VSERVER $vsname exec $DUMP | $GZIP --rsyncable > '$vroot$dumpdir/${db}.sql.gz'"
          else
-            execstr="$VSERVER $vsname exec $DUMP -r $vroot$dumpdir/${db}.sql"
+            execstr="$VSERVER $vsname exec $DUMP -r '$vroot$dumpdir/${db}.sql'"
          fi
       else
          # Test to make sure mysqld is running, if it is not sqldump will not work
@@ -282,15 +290,15 @@ then
             fatal "mysqld doesn't appear to be running!"
          fi
          if [ "$compress" == "yes" ]; then
-            execstr="$DUMP | $GZIP > $dumpdir/${db}.sql.gz"
+            execstr="$DUMP | $GZIP --rsyncable > '$dumpdir/${db}.sql.gz'"
          else
-            execstr="$DUMP -r $dumpdir/${db}.sql"
+            execstr="$DUMP -r '$dumpdir/${db}.sql'"
          fi
       fi
       debug "su $user -c \"$execstr\""
       if [ ! $test ]
       then
-         output=`su $user -c "$execstr" 2>&1`
+         output=`su $user -c "set -o pipefail ; $execstr" 2>&1`
          code=$?
          if [ "$code" == "0" ]
          then
@@ -308,12 +316,12 @@ fi
 if [ "$dbusername" != "" -a "$dbpassword" != "" ]
 then
    ## clean up tmp config file
-   debug "rm $mycnf"
-   rm $mycnf
+   debug "rm $workcnf"
+   rm $workcnf
    if [ -f "$tmpcnf" ]
    then
-      debug "mv $tmpcnf $mycnf"
-      mv $tmpcnf $mycnf
+      debug "mv $tmpcnf $workcnf"
+      mv $tmpcnf $workcnf
    fi
 fi